var bLeftOpen = false;
var iLeftEar = 1;
var bRightOpen = false;
var iRightEar = 1;
var timerEvent = "";
var bVideoVisible = false;


function init() {
	if (theme.loadPreference('Repeat') == 'True') {
		player.settings.setMode('loop',down);		
	}
	
	effects.currentEffectType = mediacenter.effectType;
	effects.currentPreset = mediacenter.effectPreset;  

	// Initial movement //
	head.top = 15;
	left_ear1.left = 31;
	right_ear1.left = 540;
	head.moveto(0,0,250);
	timerEvent = "init";
	noodle.timerInterval = 250;
}

function savePreferences() {
	theme.savePreference('LeftOpen', bLeftOpen);
	theme.savePreference('RightOpen', bRightOpen); 
	theme.savePreference('VideoVisible', bVideoVisible);
	theme.savePreference('Repeat', player.settings.getMode('loop'));
	mediacenter.effectType = effects.currentEffectType;
	mediacenter.effectPreset = effects.currentPreset;
}

function leftEarControls() {
	if (player.settings.getMode('loop')) {
		repeat.down = true;
	}
	
	// Frame 1 //
	openleft.tabStop = !bLeftOpen;
	
	// Frame 11 //
	ejectclose.tabStop = bLeftOpen;
	screen.tabStop = bLeftOpen;
	playlist.tabStop = bLeftOpen;
	closeleft.tabStop = bLeftOpen;
	vis.tabStop = bLeftOpen;
	pl.tabStop = bLeftOpen;
	repeat.tabStop = bLeftOpen;
	playback_slider.tabStop = bLeftOpen;
}

function rightEarControls() {
	// Frame 1 //
	openright1.tabStop = !bRightOpen;
	vol1.tabStop = !bRightOpen;
	
	// Frame 6 //
	leds.visible = bRightOpen;
	
	vol6.tabStop = bRightOpen;
	openright6 = bRightOpen;
	closeright = bRightOpen;
	eq_controls = bRightOpen;
	eq1.tabStop = bRightOpen;
	eq2.tabStop = bRightOpen;
	eq3.tabStop = bRightOpen;
	eq4.tabStop = bRightOpen;
	eq5.tabStop = bRightOpen;
	eq6.tabStop = bRightOpen;
	eq7.tabStop = bRightOpen;
	eq8.tabStop = bRightOpen;
	eq9.tabStop = bRightOpen;
	eq10.tabStop = bRightOpen;
}

function startTimer(event) {
	noodle.timerInterval = 60;
	timerEvent = event;
}

function stopTimer() {
	noodle.timerInterval = 0;
	timerEvent = "";
}

function timerHandler() {

	if (timerEvent == "init") {
		left_ear1.moveto(21,93,400);
		right_ear1.moveto(550,110,400);
		
		stopTimer();
		leftEarControls();
		rightEarControls();
		playStateChange();
	}
	if (timerEvent == "left") {
		if (iLeftEar == 11) {
			playlist.visible = screen.visible = video.visible = effects.visible = false;
		}
	
		showAnim = "left_ear" + iLeftEar;
		eval(showAnim).visible = false;
		
		if (!bLeftOpen) { iLeftEar = iLeftEar + 1; }
		else { iLeftEar = iLeftEar - 1; }
		
		showAnim = "left_ear" + iLeftEar;
		eval(showAnim).visible = true;
		
		if ((iLeftEar == 11)||(iLeftEar == 1)) {
			stopTimer();
			bLeftOpen = !bLeftOpen;
	
			if 	(bLeftOpen) { 
				showLeft(); 
			}
			leftEarControls();
		}
	}
	if (timerEvent == "right") {
		if (iRightEar == 6) {
			leds.visible = false;
		}
	
		showAnim = "right_ear" + iRightEar;
		eval(showAnim).visible = false;
		
		if (!bRightOpen) { iRightEar = iRightEar + 1; }
		else { iRightEar = iRightEar - 1; }
		
		showAnim = "right_ear" + iRightEar;
		eval(showAnim).visible = true;
		
		if ((iRightEar == 6)||(iRightEar == 1)) {
			stopTimer();
			bRightOpen = !bRightOpen;
			rightEarControls();
		}
	}
}


function openStateChange() {
	if((player.OpenState == osMediaOpen) && bLeftOpen)
	{
		screen.visible = true;
		video.visible = (player.currentMedia.ImageSourceWidth>0);
		effects.visible = !video.visible;
	}
}

function playStateChange() {	
	if ((player.playState==3)||(player.playState==6)||(player.playState==7)||(player.playState==9)) {  // playing, buffering, waiting, connecting
		if ((player.currentMedia.ImageSourceWidth>0) && (!bLeftOpen)) {
			bVideoVisible = true;
			startTimer('left');
		}
		if ((player.currentMedia.ImageSourceWidth>0) && (!bVideoVisible)) {
			showVideo();
		}
	}

	// Display status //
	if (player.playState==3) {	//playing
		media_name.value = player.currentMedia.name;
		media_name.scrolling = true;
	}
	else {
		media_name.value = player.status;
		media_name.scrolling = false;
	}	
}

function showLeft() {
	if (bVideoVisible) {
		showVideo();
	}
	else {
		showPlaylist();
	}
}

function showPlaylist() {
	screen.visible = video.visible = effects.visible = false;
	playlist.visible = true;
	vis.visible = true;
	pl.visible = false;
	
	bVideoVisible = false;
}

function showVideo() {
	playlist.visible = false;
	pl.visible = true;
	vis.visible = false;
	
	if (!bLeftOpen) {
		playlist.visible = screen.visible = video.visible = effects.visible = false;	// just in case...
		startTimer('left');
	}
	else {
		screen.visible = true;
		video.visible = (player.currentMedia.ImageSourceWidth>0);
		effects.visible = !video.visible;	
	}
	
	bVideoVisible = true;
}

function showVisuals() {
	playlist.visible = false;
	pl.visible = true;
	vis.visible = false;
	
	if (bLeftOpen) {
		screen.visible = true;
		video.visible = (player.currentMedia.ImageSourceWidth>0);
		effects.visible = !video.visible;
	}
	else {
		playlist.visible = screen.visible = video.visible = effects.visible = false;
	}
	
	bVideoVisible = true;
}
